package dev.pfaff.altargui.util.listenable;

public final class ListenableFlag extends AbstractListenable {
	private boolean value;

	public ListenableFlag(boolean initialValue) {
		value = initialValue;
	}

	private void notifyListeners() {
		notifyRunnableListeners();
	}

	public boolean value() {
		return this.value;
	}

	public boolean takeNoNotify() {
		var value = this.value;
		this.value = false;
		return value;
	}

	public void value(boolean value) {
		if (this.value != value) {
			this.value = value;
			notifyListeners();
		}
	}

	public void valueNoNotify(boolean value) {
		if (this.value != value) {
			this.value = value;
		}
	}

	public void clear() {
		value(false);
	}

	public void clearNoNotify() {
		valueNoNotify(false);
	}

	public void set() {
		value(true);
	}

	public void setNoNotify() {
		valueNoNotify(true);
	}

	public void toggle() {
		value(!value());
	}

	public void toggleNoNotify() {
		valueNoNotify(!value());
	}
}
